function XSILoadPlugin(in_reg)

	in_reg.Author = "GOTETZ"
	in_reg.Name = "GTEnvWeightIOPlugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "GTSaveEnvWeight", "GTSaveEnvWeight"
	in_reg.RegisterCommand "GTLoadEnvWeight", "GTLoadEnvWeight"
	in_reg.RegisterMenu siMenuTbAnimateDeformEnvelopeID, "GTLoadEnvWeight_Menu", false
	
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
	
end function

'----------------------------------------------

function XSIUnloadPlugin(in_reg)

	dim strPluginName
	strPluginName = in_reg.Name
	Application.LogMessage strPluginName & " has been unloaded.",siVerbose
	XSIUnloadPlugin = true
	
end function

'----------------------------------------------

function GTSaveEnvWeight_Init(in_ctxt)

	dim oCmd
	set oCmd = in_ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	GTSaveEnvWeight_Init = true
	
end function

'----------------------------------------------

function GTLoadEnvWeight_Init(in_ctxt)

	dim oCmd
	set oCmd = in_ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	GTLoadEnvWeight_Init = true
	
end function

'----------------------------------------------

function GTLoadEnvWeight_Menu_Init(in_ctxt)

	set menu = in_ctxt.Source
	set subMenu = menu.AddItem("GT EnvelopeWeight IO", siMenuItemSubmenu)
	submenu.AddCommandItem "Save Weight", "GTSaveEnvWeight"
	submenu.AddCommandItem "Load Weight", "GTLoadEnvWeight"
	
	Select_Points_Menu_Init = true
	
end function

'----------------------------------------------

function GTSaveEnvWeight_Execute()

	'Application.LogMessage "GTSaveEnvWeight_Execute called",siVerbose

	dir = XSIUtils.BuildPath(ActiveProject.Path, "Envelope")
	set fso = CreateObject("Scripting.FileSystemObject")
	if not fso.FolderExists(dir) then
		fso.CreateFolder dir
	end if
	
	set cSel = SIFilter(selection, siPolyMeshFilter)
	if cSel is Nothing then
		msgBox "Please select object(s).", , "SaveEnvWeight"
		logmessage "< SaveEnvWeight > Cancelled."
		exit function
	end if
		
	resultMsg = "###### Results ######" & vbCrLf & vbCrLf
	for each obj in cSel
		bSave = False
		set envOp = obj.Envelopes(0)
		if not envOp is Nothing then
			'set envCls = envOp.InputPorts(3).Target2
			set envProp = envOp.InputPorts(4).Target2
			filepath = XSIUtils.BuildPath(dir,obj.Name & ".Preset")
			SavePreset envProp, filepath
			bSave = True
		end if
		resultMsg = resultMsg & "    " & obj.Name & " : "
		if bSave then
			resultMsg = resultMsg & "[OK]" & vbTab & vbCrLf
		else
			resultMsg = resultMsg & "[Skip]" & vbTab & vbCrLf
		end if
	next
	msgBox resultMsg, , "SaveEnvWeight"
	logmessage "< SaveEnvWeight > Process Completed."

	GTSaveEnvWeight_Execute = true

end function

'----------------------------------------------

function GTLoadEnvWeight_Execute()

	'Application.LogMessage "GTLoadEnvWeight_Execute called",siVerbose

	dir = XSIUtils.BuildPath(ActiveProject.Path, "Envelope")
	set fso = CreateObject("Scripting.FileSystemObject")
	if not fso.FolderExists(dir) then
		msgBox "Preset file(s) not found.", , "GTLoadEnvWeight"
		logmessage "< LoadEnvWeight > Cancelled."
		exit function
	end if
	
	set cSel = SIFilter(selection, siPolyMeshFilter)
	if cSel is Nothing then
		msgBox "Please select object(s).", , "GTLoadEnvWeight"
		logmessage "< LoadEnvWeight > Cancelled."
		exit function
	end if
	
	resultMsg = "###### Results ######" & vbCrLf & vbCrLf
	for each obj in cSel
		bLoad = False
		set envOp = obj.Envelopes(0)
		if not envOp is Nothing then
			filepath = XSIUtils.BuildPath(dir, obj.Name & ".Preset")
			if fso.FileExists(filepath) then
				'set envCls = envOp.InputPorts(3).Target2
				set envProp = envOp.InputPorts(4).Target2
				LoadPreset filepath, envProp
				bLoad = True
			end if
		end if
		resultMsg = resultMsg & "    " & obj.Name & " : "
		if bLoad then
			resultMsg = resultMsg & "[OK]" & vbTab & vbCrLf
		else
			resultMsg = resultMsg & "[Skip]" & vbTab & vbCrLf
		end if
	next
	msgBox resultMsg, , "LoadEnvWeight"
	logmessage "< LoadEnvWeight > Process Completed."
	
	GTLoadEnvWeight_Execute = true
	
end function

