function XSILoadPlugin(in_reg)

	in_reg.Author = "GOTETZ"
	in_reg.Name = "GTLockUnselDeformersPlugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "GTLockUnselDeformers", "GTLockUnselDeformers"
	in_reg.RegisterMenu siMenuTbAnimateDeformEnvelopeID, "GTLockUnselDeformers_Menu", false
	
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
	
end function

'----------------------------------------------

function XSIUnloadPlugin(in_reg)

	dim strPluginName
	strPluginName = in_reg.Name
	Application.LogMessage strPluginName & " has been unloaded.",siVerbose
	XSIUnloadPlugin = true
	
end function

'----------------------------------------------

function GTLockUnselDeformers_Init(in_ctxt)

	dim oCmd
	set oCmd = in_ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	GTLockUnselDeformers_Init = true
	
end function

'----------------------------------------------


function GTLockUnselDeformers_Menu_Init(in_ctxt)

	set oMenu = in_ctxt.Source
	oMenu.AddCommandItem "GT Lock Unselected Deformers", "GTLockUnselDeformers"
	
	Select_Points_Menu_Init = true
	
end function

'----------------------------------------------

function GTLockUnselDeformers_Execute()

	'Application.LogMessage "GTLockUnselDeformers_Execute called",siVerbose

	errMsg = "Please select PolygonMesh and Deformers."

	set cSel = GetValue("SelectionList")
	if cSel.Count < 2 then
		msgBox errMsg, , "LockUnselDeformers"
		exit function
	end if

	set obj = cSel(0)
	if obj.Type <> siPolyMeshType then
		msgBox errMsg, , "LockUnselDeformers"
		exit function
	end if

	cSel.Remove(obj)

	set envOp = obj.Envelopes(0)
	'set envCls = envOp.InputPorts(3).Target2
	set envProp = envOp.InputPorts(4).Target2
	set cDef = CreateObject("XSI.Collection")
	cDef.AddItems(envOp.Deformers)
	set cBon = CreateObject("XSI.Collection")
	for each bon in cSel
		for each def in cDef
			if bon.iSEqualTo(def) then
				cBon.Add(def)
				exit for
			end if
		next
	next
	if cBon.Count = 0 then
		msgBox errMsg, , "LockUnselDeformers"
		exit function
	end if

	LockEnvelopeDeformerWeights envProp, cDef, true
	LockEnvelopeDeformerWeights envProp, cBon, false

	GTLockUnselDeformers_Execute = true
	
end function

