sub LoadEnvWeights

	dir = XSIUtils.BuildPath(ActiveProject.Path, "Envelope")
	set fso = CreateObject("Scripting.FileSystemObject")
	if not fso.FolderExists(dir) then
		msgBox "Preset file(s) not found.", , "LoadEnvWeights"
		logmessage "< LoadEnvWeights > Cancelled."
		exit sub
	end if
	
	set cSel = SIFilter(selection, siPolyMeshFilter)
	if cSel is Nothing then
		msgBox "Please select object(s).", , "LoadEnvWeights"
		logmessage "< LoadEnvWeights > Cancelled."
		exit sub
	end if
	
	resultMsg = "###### Results ######" & vbCrLf & vbCrLf
	for each obj in cSel
		bLoad = False
		set envOp = obj.Envelopes(0)
		if not envOp is Nothing then
			filepath = XSIUtils.BuildPath(dir, obj.Name & ".Preset")
			if fso.FileExists(filepath) then
				'set envCls = envOp.InputPorts(3).Target2
				set envProp = envOp.InputPorts(4).Target2
				LoadPreset filepath, envProp
				bLoad = True
			end if
		end if
		resultMsg = resultMsg & "    " & obj.Name & " : "
		if bLoad then
			resultMsg = resultMsg & "[OK]" & vbTab & vbCrLf
		else
			resultMsg = resultMsg & "[Skip]" & vbTab & vbCrLf
		end if
	next
	msgBox resultMsg, , "LoadEnvWeights"
	logmessage "< LoadEnvWeights > Process Completed."
end sub

LoadEnvWeights()
