sub SaveEnvWeights

	dir = XSIUtils.BuildPath(ActiveProject.Path, "Envelope")
	set fso = CreateObject("Scripting.FileSystemObject")
	if not fso.FolderExists(dir) then
		fso.CreateFolder dir
	end if
	
	set cSel = SIFilter(selection, siPolyMeshFilter)
	if cSel is Nothing then
		msgBox "Please select object(s).", , "SaveEnvWeights"
		logmessage "< SaveEnvWeights > Cancelled."
		exit sub
	end if
		
	resultMsg = "###### Results ######" & vbCrLf & vbCrLf
	for each obj in cSel
		bSave = False
		set envOp = obj.Envelopes(0)
		if not envOp is Nothing then
			'set envCls = envOp.InputPorts(3).Target2
			set envProp = envOp.InputPorts(4).Target2
			filepath = XSIUtils.BuildPath(dir,obj.Name & ".Preset")
			SavePreset envProp, filepath
			bSave = True
		end if
		resultMsg = resultMsg & "    " & obj.Name & " : "
		if bSave then
			resultMsg = resultMsg & "[OK]" & vbTab & vbCrLf
		else
			resultMsg = resultMsg & "[Skip]" & vbTab & vbCrLf
		end if
	next
	msgBox resultMsg, , "SaveEnvWeights"
	logmessage "< SaveEnvWeights > Process Completed."
end sub

SaveEnvWeights()